Overview | Package | Class | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## de.grogra.graph
Class GraphFilter

    java.lang.Object
      de.grogra.graph.GraphBase
          de.grogra.graph.GraphFilter

All Implemented Interfaces:
  AttributeChangeListener, ChangeBoundaryListener, EdgeChangeListener, Graph, Lockable

Direct Known Subclasses:
  AttributeOverwritingFilter

    public abstract class GraphFilter

extends GraphBase
implements ChangeBoundaryListener, AttributeChangeListener, EdgeChangeListener

A `GraphFilter` is a `Graph` which has another graph as source and filters the data of the source graph. Filtering may include modification of structure and attributes. The implementations of `Graph` methods in this class just forward their invocation to the corresponding methods of the source graph.

Author:
  Ole Kniemeyer

Nested Class Summary
`class` | `GraphFilter.AccessorBridge` This helper class delegates accessor method invocations to the corresponding `get`-, `set`- and `isWritable`-methods of the enclosing graph filter.
`protected class` | `GraphFilter.State`

Nested classes/interfaces inherited from interface de.grogra.util.Lockable
`Lockable.DeadLockException`

Field Summary
`protected Graph` | `source` The source graph whose data is filtered by this graph filter.

Fields inherited from interface de.grogra.graph.ChangeBoundaryListener
`ATTRIBUTE_PRIORITY, TOPOLOGY_PRIORITY, UPDATE_PRIORITY`

Fields inherited from interface de.grogra.graph.Graph
`BRANCH_EDGE, CONTAINMENT_EDGE, CONTAINMENT_END_EDGE, EDGENODE_IN_EDGE, EDGENODE_OUT_EDGE, ELLIPSE_SYMBOL, MAIN_GRAPH, MARK_EDGE, MIN_NORMAL_BIT_INDEX, MIN_UNUSED_EDGE, MIN_UNUSED_EDGE_BIT, NOTIFIES_EDGE, PERSISTENT, PERSISTENT_DELETED, RECTANGLE_SYMBOL, REFINEMENT_EDGE, RHOMBUS_SYMBOL, ROUND_RECTANGLE_SYMBOL, SPECIAL_EDGE_MASK, SPECIAL_EDGE_OF_SOURCE_BIT, STD_EDGE_5, STD_EDGE_6, SUCCESSOR_EDGE, TRANSIENT`

Constructor Summary
`GraphFilter(Graph source)`

Method Summary
`protected void` | `accept(java.lang.Object startNode, Visitor visitor, ArrayPath placeInPath, boolean useInstancing)`
`void` | `attributeChanged(AttributeChangeEvent event)`
`void` | `beginChange(GraphState gs)`
`BooleanMap` | `createBooleanMap()`
`protected GraphBase.State` | `createMainState()`
`
`<V> ObjectMap<V>`
` | `createObjectMap()`
`protected GraphState` | `createState(ThreadContext tc)`
`void` | `edgeChanged(java.lang.Object source, java.lang.Object target, java.lang.Object edgeSet, GraphState gs)`
`void` | `endChange(GraphState gs)`
`AttributeAccessor` | `getAccessor(java.lang.Object object, boolean asNode, Attribute attribute)` Returns an attribute accessor for the given attribute on the given object.
`Attribute[]` | `getAttributes(java.lang.Object object, boolean asNode)` Returns the set of attributes which are available for the given object.
`protected boolean` | `getBoolean(java.lang.Object object, GraphFilter.AccessorBridge accessor, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `BooleanAttributeAccessor.getBoolean(Object, GraphState)` to this method.
`protected byte` | `getByte(java.lang.Object object, GraphFilter.AccessorBridge accessor, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `ByteAttributeAccessor.getByte(Object, GraphState)` to this method.
`protected char` | `getChar(java.lang.Object object, GraphFilter.AccessorBridge accessor, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `CharAttributeAccessor.getChar(Object, GraphState)` to this method.
`int` | `getColor(java.lang.Object object, boolean asNode)`
`Attribute[]` | `getDependent(java.lang.Object object, boolean asNode, Attribute a)` Returns the set of attributes whose values depend on the given attribute `a` for the given `object`.
`protected Attribute[]` | `getDependentOfSource(java.lang.Object object, boolean asNode, Attribute a)`
`java.lang.Object` | `getDescription(java.lang.Object object, boolean asNode, java.lang.String type)` Returns a description for the given object.
`protected double` | `getDouble(java.lang.Object object, GraphFilter.AccessorBridge accessor, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `DoubleAttributeAccessor.getDouble(Object, GraphState)` to this method.
`int` | `getEdgeBits(java.lang.Object edge)` Returns the edge bits of an edge.
`java.lang.Object` | `getFirstEdge(java.lang.Object node)` Returns the first edge of the linked list of edges of `node`.
`protected float` | `getFloat(java.lang.Object object, GraphFilter.AccessorBridge accessor, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `FloatAttributeAccessor.getFloat(Object, GraphState)` to this method.
`long` | `getId(java.lang.Object node)` Returns a unique identifier for the given `node`.
`Instantiator` | `getInstantiator(java.lang.Object node)`
`protected int` | `getInt(java.lang.Object object, GraphFilter.AccessorBridge accessor, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `IntAttributeAccessor.getInt(Object, GraphState)` to this method.
`int` | `getLifeCycleState(java.lang.Object object, boolean asNode)` Returns the life cycle state of the given object as part of this graph.
`protected long` | `getLong(java.lang.Object object, GraphFilter.AccessorBridge accessor, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `LongAttributeAccessor.getLong(Object, GraphState)` to this method.
`java.lang.String` | `getName(java.lang.Object object, boolean asNode)` Returns a name for the given object.
`java.lang.Object` | `getNextEdge(java.lang.Object edge, java.lang.Object parentNode)` Returns the edge after `edge` in the linked list of edges of `node`.
`java.lang.Object` | `getNodeForId(long persistentId)` Returns the node identified by `id`.
`protected java.lang.Object` | `getObject(java.lang.Object object, GraphFilter.AccessorBridge accessor, java.lang.Object placeIn, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `ObjectAttributeAccessor.getObject(Object, GraphState)` and `ObjectAttributeAccessor.getObject(Object, Object, GraphState)` to this method.
`java.lang.Object` | `getObjectForName(boolean node, java.lang.String name)` Returns the object with the given name.
`ObjectAttribute` | `getParentAttribute()` Defines the derived attribute which has as value the parent object.
`int` | `getPriority()`
`java.lang.Object` | `getRoot(java.lang.String key)` Returns the root node for the given root key.
`java.lang.String[]` | `getRootKeys()` Returns the root keys for the graph.
`protected short` | `getShort(java.lang.Object object, GraphFilter.AccessorBridge accessor, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `ShortAttributeAccessor.getShort(Object, GraphState)` to this method.
`java.lang.Object` | `getSourceNode(java.lang.Object edge)` Returns the source node of `edge`.
`static GraphState` | `getSourceState(GraphState gs)`
`SpecialEdgeDescriptor[]` | `getSpecialEdgeDescriptors(java.lang.Object node, boolean asSource)`
`int` | `getStamp()` Returns a modification stamp for the whole graph.
`int` | `getSymbol(java.lang.Object object, boolean asNode)`
`java.lang.Object` | `getTargetNode(java.lang.Object edge)` Returns the target node of `edge`.
`EdgePattern` | `getTreePattern()` Defines the pattern used for the construction of this graph's tree.
`protected boolean` | `isWritable(java.lang.Object object, GraphFilter.AccessorBridge accessor, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `AttributeAccessor.isWritable(Object, GraphState)` to this method.
`protected boolean` | `setBoolean(java.lang.Object object, GraphFilter.AccessorBridge accessor, boolean value, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `BooleanAttributeAccessor.setBoolean(Object, boolean, GraphState)` to this method.
`protected byte` | `setByte(java.lang.Object object, GraphFilter.AccessorBridge accessor, byte value, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `ByteAttributeAccessor.setByte(Object, byte, GraphState)` to this method.
`protected char` | `setChar(java.lang.Object object, GraphFilter.AccessorBridge accessor, char value, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `CharAttributeAccessor.setChar(Object, char, GraphState)` to this method.
`protected double` | `setDouble(java.lang.Object object, GraphFilter.AccessorBridge accessor, double value, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `DoubleAttributeAccessor.setDouble(Object, double, GraphState)` to this method.
`protected float` | `setFloat(java.lang.Object object, GraphFilter.AccessorBridge accessor, float value, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `FloatAttributeAccessor.setFloat(Object, float, GraphState)` to this method.
`protected int` | `setInt(java.lang.Object object, GraphFilter.AccessorBridge accessor, int value, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `IntAttributeAccessor.setInt(Object, int, GraphState)` to this method.
`protected long` | `setLong(java.lang.Object object, GraphFilter.AccessorBridge accessor, long value, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `LongAttributeAccessor.setLong(Object, long, GraphState)` to this method.
`protected java.lang.Object` | `setObject(java.lang.Object object, GraphFilter.AccessorBridge accessor, java.lang.Object value, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `ObjectAttributeAccessor.setObject(Object, Object, GraphState)` to this method.
`protected short` | `setShort(java.lang.Object object, GraphFilter.AccessorBridge accessor, short value, GraphState gs)` `GraphFilter.AccessorBridge` forwards the invocation of `ShortAttributeAccessor.setShort(Object, short, GraphState)` to this method.

Methods inherited from class de.grogra.graph.GraphBase
`addAttributeChangeListener, addAttributeChangeListener, addChangeBoundaryListener, addEdgeChangeListener, addEdgeChangeListener, execute, execute, executeForcedly, executeForcedly, getMainState, getMaxWaitingTime, getQueueLength, getStateMap, init, isLocked, removeAttributeChangeListener, removeAttributeChangeListener, removeChangeBoundaryListener, removeEdgeChangeListener, removeEdgeChangeListener`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface de.grogra.graph.Graph
`accept`

Field Detail

### source

    protected final Graph source

  The source graph whose data is filtered by this graph filter.

Constructor Detail

### GraphFilter

    public GraphFilter(Graph source)

Method Detail

### accept

    protected void accept(java.lang.Object startNode,
                          Visitor visitor,
                          ArrayPath placeInPath,
                          boolean useInstancing)

### attributeChanged

    public void attributeChanged(AttributeChangeEvent event)

  Specified by:
    `attributeChanged` in interface `AttributeChangeListener`

### beginChange

    public void beginChange(GraphState gs)

  Specified by:
    `beginChange` in interface `ChangeBoundaryListener`

### createBooleanMap

    public BooleanMap createBooleanMap()

  Specified by:
    `createBooleanMap` in interface `Graph`

### createMainState

    protected GraphBase.State createMainState()

  Specified by:
    `createMainState` in class `GraphBase`

### createObjectMap

    public <V> ObjectMap<V> createObjectMap()

  Specified by:
    `createObjectMap` in interface `Graph`

### createState

    protected GraphState createState(ThreadContext tc)

### edgeChanged

    public void edgeChanged(java.lang.Object source,
                            java.lang.Object target,
                            java.lang.Object edgeSet,
                            GraphState gs)

  Specified by:
    `edgeChanged` in interface `EdgeChangeListener`

### endChange

    public void endChange(GraphState gs)

  Specified by:
    `endChange` in interface `ChangeBoundaryListener`

### getAccessor

    public AttributeAccessor getAccessor(java.lang.Object object,
                                         boolean asNode,
                                         Attribute attribute)

  Description copied from interface: `Graph`
  Returns an attribute accessor for the given attribute on the given object.

  Specified by:
    `getAccessor` in interface `Graph`
  Parameters:
    `object` - the object
    `asNode` - `true` if `object` is a node, `false` if `object` is an edge
    `attribute` - the attribute
  Returns:
    an accessor for the object's attribute value

### getAttributes

    public Attribute[] getAttributes(java.lang.Object object,
                                     boolean asNode)

  Description copied from interface: `Graph`
  Returns the set of attributes which are available for the given object.

  Specified by:
    `getAttributes` in interface `Graph`
  Parameters:
    `object` - the object
    `asNode` - `true` if `object` is a node, `false` if `object` is an edge
  Returns:
    the object's attributes

### getBoolean

    protected boolean getBoolean(java.lang.Object object,
                                 GraphFilter.AccessorBridge accessor,
                                 GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `BooleanAttributeAccessor.getBoolean(Object, GraphState)` to this method. This method has to be overridden by subclasses which make use of accessor bridges in order to return the value for the attribute of the accessor bridge.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `gs` - current graph state
  Returns:
    value of the accessor's attribute for the object
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### getByte

    protected byte getByte(java.lang.Object object,
                           GraphFilter.AccessorBridge accessor,
                           GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `ByteAttributeAccessor.getByte(Object, GraphState)` to this method. This method has to be overridden by subclasses which make use of accessor bridges in order to return the value for the attribute of the accessor bridge.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `gs` - current graph state
  Returns:
    value of the accessor's attribute for the object
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### getChar

    protected char getChar(java.lang.Object object,
                           GraphFilter.AccessorBridge accessor,
                           GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `CharAttributeAccessor.getChar(Object, GraphState)` to this method. This method has to be overridden by subclasses which make use of accessor bridges in order to return the value for the attribute of the accessor bridge.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `gs` - current graph state
  Returns:
    value of the accessor's attribute for the object
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### getColor

    public int getColor(java.lang.Object object,
                        boolean asNode)

  Specified by:
    `getColor` in interface `Graph`

### getDependent

    public Attribute[] getDependent(java.lang.Object object,
                                    boolean asNode,
                                    Attribute a)

  Description copied from interface: `Graph`
  Returns the set of attributes whose values depend on the given attribute `a` for the given `object`.

  Specified by:
    `getDependent` in interface `Graph`
  Parameters:
    `object` - the object
    `asNode` - `true` if `object` is a node, `false` if `object` is an edge
    `a` - the attribute
  Returns:
    the set of dependent attributes

### getDependentOfSource

    protected Attribute[] getDependentOfSource(java.lang.Object object,
                                               boolean asNode,
                                               Attribute a)

### getDescription

    public java.lang.Object getDescription(java.lang.Object object,
                                           boolean asNode,
                                           java.lang.String type)

  Description copied from interface: `Graph`
  Returns a description for the given object. The type of the desired description (e.g., text, icon) is specified in the argument `type`; it is interpreted as in `Described.getDescription(String)`.

  Specified by:
    `getDescription` in interface `Graph`
  Parameters:
    `object` - the object
    `asNode` - `true` if `object` is a node, `false` if `object` is an edge
    `type` - the type of description
  Returns:
    a description of the given type, or `null`

### getDouble

    protected double getDouble(java.lang.Object object,
                               GraphFilter.AccessorBridge accessor,
                               GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `DoubleAttributeAccessor.getDouble(Object, GraphState)` to this method. This method has to be overridden by subclasses which make use of accessor bridges in order to return the value for the attribute of the accessor bridge.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `gs` - current graph state
  Returns:
    value of the accessor's attribute for the object
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### getEdgeBits

    public int getEdgeBits(java.lang.Object edge)

  Description copied from interface: `Graph`
  Returns the edge bits of an edge.

  Specified by:
    `getEdgeBits` in interface `Graph`
  Parameters:
    `edge` - the edge
  Returns:
    the edge's edge bits
  See Also:
    `Graph`

### getFirstEdge

    public java.lang.Object getFirstEdge(java.lang.Object node)

  Description copied from interface: `Graph`
  Returns the first edge of the linked list of edges of `node`.

  Specified by:
    `getFirstEdge` in interface `Graph`
  Parameters:
    `node` - the common node of the edges of the linked list
  Returns:
    the first edge of the linked list
  See Also:
    `Graph`, `Graph.getNextEdge(Object, Object)`

### getFloat

    protected float getFloat(java.lang.Object object,
                             GraphFilter.AccessorBridge accessor,
                             GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `FloatAttributeAccessor.getFloat(Object, GraphState)` to this method. This method has to be overridden by subclasses which make use of accessor bridges in order to return the value for the attribute of the accessor bridge.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `gs` - current graph state
  Returns:
    value of the accessor's attribute for the object
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### getId

    public long getId(java.lang.Object node)

  Description copied from interface: `Graph`
  Returns a unique identifier for the given `node`.

  Specified by:
    `getId` in interface `Graph`
  Parameters:
    `node` - a node
  Returns:
    the node's unique identifier
  See Also:
    `Graph.getNodeForId(long)`

### getInstantiator

    public Instantiator getInstantiator(java.lang.Object node)

  Specified by:
    `getInstantiator` in interface `Graph`

### getInt

    protected int getInt(java.lang.Object object,
                         GraphFilter.AccessorBridge accessor,
                         GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `IntAttributeAccessor.getInt(Object, GraphState)` to this method. This method has to be overridden by subclasses which make use of accessor bridges in order to return the value for the attribute of the accessor bridge.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `gs` - current graph state
  Returns:
    value of the accessor's attribute for the object
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### getLifeCycleState

    public int getLifeCycleState(java.lang.Object object,
                                 boolean asNode)

  Description copied from interface: `Graph`
  Returns the life cycle state of the given object as part of this graph.

  Specified by:
    `getLifeCycleState` in interface `Graph`
  Parameters:
    `object` - the object to test
    `asNode` - `true` if `object` is a node, `false` if `object` is an edge
  Returns:
    life cycle state, one of `Graph.PERSISTENT`, `Graph.PERSISTENT_DELETED`, `Graph.TRANSIENT`

### getLong

    protected long getLong(java.lang.Object object,
                           GraphFilter.AccessorBridge accessor,
                           GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `LongAttributeAccessor.getLong(Object, GraphState)` to this method. This method has to be overridden by subclasses which make use of accessor bridges in order to return the value for the attribute of the accessor bridge.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `gs` - current graph state
  Returns:
    value of the accessor's attribute for the object
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### getName

    public java.lang.String getName(java.lang.Object object,
                                    boolean asNode)

  Description copied from interface: `Graph`
  Returns a name for the given object. Names are not necessarily unique.

  Specified by:
    `getName` in interface `Graph`
  Parameters:
    `object` - the object
    `asNode` - `true` if `object` is a node, `false` if `object` is an edge
  Returns:
    a name
  See Also:
    `Graph.getObjectForName(boolean, String)`

### getNextEdge

    public java.lang.Object getNextEdge(java.lang.Object edge,
                                        java.lang.Object parentNode)

  Description copied from interface: `Graph`
  Returns the edge after `edge` in the linked list of edges of `node`.

  Specified by:
    `getNextEdge` in interface `Graph`
  Parameters:
    `edge` - the previous edge in the linked list
    `parentNode` - the common node of the edges of the linked list
  Returns:
    the next edge of the linked list
  See Also:
    `Graph`, `Graph.getFirstEdge(Object)`

### getNodeForId

    public java.lang.Object getNodeForId(long persistentId)

  Description copied from interface: `Graph`
  Returns the node identified by `id`.

  Specified by:
    `getNodeForId` in interface `Graph`
  Parameters:
    `persistentId` - an identifier
  Returns:
    the corresponding node, or `null` if `id` identifies no node
  See Also:
    `Graph.getId(Object)`

### getObject

    protected java.lang.Object getObject(java.lang.Object object,
                                         GraphFilter.AccessorBridge accessor,
                                         java.lang.Object placeIn,
                                         GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `ObjectAttributeAccessor.getObject(Object, GraphState)` and `ObjectAttributeAccessor.getObject(Object, Object, GraphState)` to this method. This method has to be overridden by subclasses which make use of accessor bridges in order to return the value for the attribute of the accessor bridge.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `placeIn` - an instance for the result may be provided by the caller
    `gs` - current graph state
  Returns:
    value of the accessor's attribute for the object
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### getObjectForName

    public java.lang.Object getObjectForName(boolean node,
                                             java.lang.String name)

  Description copied from interface: `Graph`
  Returns the object with the given name. If several such objects exist, one of them is chosen in an unspecified manner. If no such object exists, `null` is returned.

  Specified by:
    `getObjectForName` in interface `Graph`
  Parameters:
    `node` - `true` if a node of the given name is to be found, `false` if an edge is to be found
    `name` - the name of the object
  Returns:
    an object of the given kind (node or edge) with the given name, or `null` if no such object exists
  See Also:
    `Graph.getName(Object, boolean)`

### getParentAttribute

    public ObjectAttribute getParentAttribute()

  Description copied from interface: `Graph`
  Defines the derived attribute which has as value the parent object.

  Specified by:
    `getParentAttribute` in interface `Graph`
  Returns:
    the parent attribute
  See Also:
    `Graph`, `Graph.getTreePattern()`

### getPriority

    public int getPriority()

  Specified by:
    `getPriority` in interface `ChangeBoundaryListener`

### getRoot

    public java.lang.Object getRoot(java.lang.String key)

  Description copied from interface: `Graph`
  Returns the root node for the given root key.

  Specified by:
    `getRoot` in interface `Graph`
  Parameters:
    `key` - a root key, one of `Graph.getRootKeys()`
  Returns:
    the root node of the graph identified by `key`, or `null` if no such root node exists
  See Also:
    `Graph`

### getRootKeys

    public java.lang.String[] getRootKeys()

  Description copied from interface: `Graph`
  Returns the root keys for the graph.

  Specified by:
    `getRootKeys` in interface `Graph`
  Returns:
    an array of root keys
  See Also:
    `Graph`, `Graph.getRoot(String)`

### getShort

    protected short getShort(java.lang.Object object,
                             GraphFilter.AccessorBridge accessor,
                             GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `ShortAttributeAccessor.getShort(Object, GraphState)` to this method. This method has to be overridden by subclasses which make use of accessor bridges in order to return the value for the attribute of the accessor bridge.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `gs` - current graph state
  Returns:
    value of the accessor's attribute for the object
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### getSourceNode

    public java.lang.Object getSourceNode(java.lang.Object edge)

  Description copied from interface: `Graph`
  Returns the source node of `edge`.

  Specified by:
    `getSourceNode` in interface `Graph`
  Parameters:
    `edge` - an edge
  Returns:
    the source node
  See Also:
    `Graph`

### getSourceState

    public static GraphState getSourceState(GraphState gs)

### getSpecialEdgeDescriptors

    public SpecialEdgeDescriptor[] getSpecialEdgeDescriptors(java.lang.Object node,
                                                             boolean asSource)

  Specified by:
    `getSpecialEdgeDescriptors` in interface `Graph`

### getStamp

    public int getStamp()

  Description copied from interface: `Graph`
  Returns a modification stamp for the whole graph. Each modification increments the value, so that the test whether some modification occured can be simply performed on values of the stamp.

  Specified by:
    `getStamp` in interface `Graph`
  Returns:
    a stamp for the whole graph

### getSymbol

    public int getSymbol(java.lang.Object object,
                         boolean asNode)

  Specified by:
    `getSymbol` in interface `Graph`

### getTargetNode

    public java.lang.Object getTargetNode(java.lang.Object edge)

  Description copied from interface: `Graph`
  Returns the target node of `edge`.

  Specified by:
    `getTargetNode` in interface `Graph`
  Parameters:
    `edge` - an edge
  Returns:
    the target node
  See Also:
    `Graph`

### getTreePattern

    public EdgePattern getTreePattern()

  Description copied from interface: `Graph`
  Defines the pattern used for the construction of this graph's tree.

  Specified by:
    `getTreePattern` in interface `Graph`
  Returns:
    an edge pattern
  See Also:
    `Graph`, `Graph.getParentAttribute()`

### isWritable

    protected boolean isWritable(java.lang.Object object,
                                 GraphFilter.AccessorBridge accessor,
                                 GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `AttributeAccessor.isWritable(Object, GraphState)` to this method. This method has to be overridden by subclasses which declare a writable attribute by an accessor bridge.

  Parameters:
    `object` - an object
    `accessor` - an accessor bridge
    `gs` - current graph state
  Returns:
    `true` iff `accessor` represents a writable attribute

### setBoolean

    protected boolean setBoolean(java.lang.Object object,
                                 GraphFilter.AccessorBridge accessor,
                                 boolean value,
                                 GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `BooleanAttributeAccessor.setBoolean(Object, boolean, GraphState)` to this method. This method has to be overridden by subclasses which use accessor bridges to represent writable attributes.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `value` - the new value for the attribute
    `gs` - current graph state
  Returns:
    actual new value of the attribute
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### setByte

    protected byte setByte(java.lang.Object object,
                           GraphFilter.AccessorBridge accessor,
                           byte value,
                           GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `ByteAttributeAccessor.setByte(Object, byte, GraphState)` to this method. This method has to be overridden by subclasses which use accessor bridges to represent writable attributes.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `value` - the new value for the attribute
    `gs` - current graph state
  Returns:
    actual new value of the attribute
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### setChar

    protected char setChar(java.lang.Object object,
                           GraphFilter.AccessorBridge accessor,
                           char value,
                           GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `CharAttributeAccessor.setChar(Object, char, GraphState)` to this method. This method has to be overridden by subclasses which use accessor bridges to represent writable attributes.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `value` - the new value for the attribute
    `gs` - current graph state
  Returns:
    actual new value of the attribute
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### setDouble

    protected double setDouble(java.lang.Object object,
                               GraphFilter.AccessorBridge accessor,
                               double value,
                               GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `DoubleAttributeAccessor.setDouble(Object, double, GraphState)` to this method. This method has to be overridden by subclasses which use accessor bridges to represent writable attributes.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `value` - the new value for the attribute
    `gs` - current graph state
  Returns:
    actual new value of the attribute
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### setFloat

    protected float setFloat(java.lang.Object object,
                             GraphFilter.AccessorBridge accessor,
                             float value,
                             GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `FloatAttributeAccessor.setFloat(Object, float, GraphState)` to this method. This method has to be overridden by subclasses which use accessor bridges to represent writable attributes.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `value` - the new value for the attribute
    `gs` - current graph state
  Returns:
    actual new value of the attribute
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### setInt

    protected int setInt(java.lang.Object object,
                         GraphFilter.AccessorBridge accessor,
                         int value,
                         GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `IntAttributeAccessor.setInt(Object, int, GraphState)` to this method. This method has to be overridden by subclasses which use accessor bridges to represent writable attributes.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `value` - the new value for the attribute
    `gs` - current graph state
  Returns:
    actual new value of the attribute
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### setLong

    protected long setLong(java.lang.Object object,
                           GraphFilter.AccessorBridge accessor,
                           long value,
                           GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `LongAttributeAccessor.setLong(Object, long, GraphState)` to this method. This method has to be overridden by subclasses which use accessor bridges to represent writable attributes.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `value` - the new value for the attribute
    `gs` - current graph state
  Returns:
    actual new value of the attribute
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### setObject

    protected java.lang.Object setObject(java.lang.Object object,
                                         GraphFilter.AccessorBridge accessor,
                                         java.lang.Object value,
                                         GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `ObjectAttributeAccessor.setObject(Object, Object, GraphState)` to this method. This method has to be overridden by subclasses which use accessor bridges to represent writable attributes.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `value` - the new value for the attribute
    `gs` - current graph state
  Returns:
    actual new value of the attribute
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

### setShort

    protected short setShort(java.lang.Object object,
                             GraphFilter.AccessorBridge accessor,
                             short value,
                             GraphState gs)

  `GraphFilter.AccessorBridge` forwards the invocation of `ShortAttributeAccessor.setShort(Object, short, GraphState)` to this method. This method has to be overridden by subclasses which use accessor bridges to represent writable attributes.

  Parameters:
    `object` - the object
    `accessor` - the accessor bridge which invokes this method
    `value` - the new value for the attribute
    `gs` - current graph state
  Returns:
    actual new value of the attribute
  Throws:
    `NoSuchKeyException` - if the attribute is not defined for the object

Overview | Package | Class | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD